<?php

/* --------------------------------------------------------------
   SentryErrorHandler.inc.php 2018-10-12
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2018 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

$configPath = DIR_FS_CATALOG . 'GXModules/Gambio/ErrorReporting/configuration.json';
$ravenPath = DIR_FS_CATALOG . 'vendor/sentry/sentry/lib/Raven/Autoloader.php';

if(!file_exists($configPath) || !file_exists($ravenPath)) {
	return;
}

$sentryConfig = json_decode(file_get_contents($configPath), true);

if (!$sentryConfig['active']) {
	return;
}

require_once $ravenPath;
Raven_Autoloader::register();

$sentryClient = new Raven_Client($sentryConfig['dsn']);

include(DIR_FS_CATALOG . 'release_info.php');

if(file_exists(DIR_FS_CATALOG.'.dev-environment') || strpos($gx_version,'develop')!==false)
{
	$sentryClient->setEnvironment('development');
}
else
{
	$sentryClient->setEnvironment('production');
}

$sentryClient->setRelease($gx_version);
$sentryClient->setAppPath(DIR_FS_CATALOG);
$sentryClient->setPrefixes([DIR_FS_CATALOG, DIR_FS_DOCUMENT_ROOT]);
$sentryClient->install();