/* --------------------------------------------------------------
   account_emailaddress.js 2019-12-05
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

gambio.widgets.module('account_emailaddress', [], function(data) {
	'use strict';
	
	var $this = $(this),
		$body = $('body'),
		defaults = {
		},
		options = $.extend(true, {}, defaults, data),
		module = {};
	
	// ########## HELPER FUNCTIONS ##########
	
	// (none)
	
	// ########## INITIALIZATION ##########
	
	/**
	 * Init function of the widget
	 * @constructor
	 */
	module.init = function(done) {
		let $emailAddress = $('#email_address'),
			$emailConfirm = $('#email_address_confirm'),
			$emailInputs  = $('#email_address, #email_address_confirm'),
			$noMatchNote  = $('.email-no-match');
		
		$emailInputs.on('change', function() {
			let emailValue = $emailAddress.val(),
				confirmValue = $emailConfirm.val();
			
			if((emailValue.length > 0 || confirmValue.length > 0) &&
				emailValue !== confirmValue) {
				$noMatchNote.show();
				$emailAddress.closest('div.form-group').addClass('has-error');
				$emailConfirm.closest('div.form-group').addClass('has-error');
			} else {
				$noMatchNote.hide();
				$emailAddress.closest('div.form-group').removeClass('has-error');
				$emailConfirm.closest('div.form-group').removeClass('has-error');
			}
		});
		
		done();
	};
	
	// Return data to widget engine
	return module;
});
